verify-generated-runtime.sh 1.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051
  1. #!/usr/bin/env bash
  2. # Copyright 2016 The Kubernetes Authors.
  3. #
  4. # Licensed under the Apache License, Version 2.0 (the "License");
  5. # you may not use this file except in compliance with the License.
  6. # You may obtain a copy of the License at
  7. #
  8. # http://www.apache.org/licenses/LICENSE-2.0
  9. #
  10. # Unless required by applicable law or agreed to in writing, software
  11. # distributed under the License is distributed on an "AS IS" BASIS,
  12. # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  13. # See the License for the specific language governing permissions and
  14. # limitations under the License.
  15. # This script checks whether updating of container runtime API is needed or not.
  16. # We should run `hack/update-generated-runtime.sh` if container runtime API is
  17. # out of date.
  18. # Usage: `hack/verify-generated-runtime.sh`.
  19. set -o errexit
  20. set -o nounset
  21. set -o pipefail
  22. KUBE_ROOT=$(dirname "${BASH_SOURCE[0]}")/..
  23. KUBE_REMOTE_RUNTIME_ROOT="${KUBE_ROOT}/staging/src/k8s.io/cri-api/pkg/apis/runtime/v1alpha2"
  24. source "${KUBE_ROOT}/hack/lib/init.sh"
  25. kube::golang::setup_env
  26. function cleanup {
  27. rm -rf "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/"
  28. }
  29. trap cleanup EXIT
  30. mkdir -p "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp"
  31. cp "${KUBE_REMOTE_RUNTIME_ROOT}/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/"
  32. ret=0
  33. KUBE_VERBOSE=3 "${KUBE_ROOT}/hack/update-generated-runtime.sh"
  34. diff -I "gzipped FileDescriptorProto" -I "0x" -Naupr "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/api.pb.go" || ret=$?
  35. if [[ $ret -eq 0 ]]; then
  36. echo "Generated container runtime api is up to date."
  37. cp "${KUBE_REMOTE_RUNTIME_ROOT}/_tmp/api.pb.go" "${KUBE_REMOTE_RUNTIME_ROOT}/"
  38. else
  39. echo "Generated container runtime api is out of date. Please run hack/update-generated-runtime.sh"
  40. exit 1
  41. fi